// Copyright IBM Corp. 2015,2016. All Rights Reserved.
// Node module: apiconnect-collective-member
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

'use strict';

var _debug = require('debug');
var name = 'wlpn-diagnostics';

var MAX = 220;

module.exports = debug;

function debug() {
  var components = [name];
  components.push.apply(components, arguments);
  var fn = _debug(components.join(':'));
  // XXX(sam) could make this functions be nul-ops if ! fn.enabled
  fn.json = json;
  fn.json.middleware = function(req, res, next) {
    middleware(fn, req, res, next);
  };
  return fn;
}

function json(js) {
  // Don't json encode the string if debug is disabled.
  if (this.enabled) {
    var s = JSON.stringify(js);

    if (s.length < MAX)
      return s;

    return s.substring(0, MAX) + '...';
  }
  return '';
}

function middleware(debug, req, res, next) {
  if (!debug.enabled)
    return next();

  var method = req.method;
  var path = req.app.mountpath + req.path;

  debug('%s %s req: %s', method, path, debug.json(req.body));

  var _json = res.json;

  res.json = function(body) {
    debug('%s %s res: %s', method, path, debug.json(body));
    _json.call(res, body);
  };

  return next();
}
